count = 0;
secsFirst = 0;
secsPrevious = 0;
var refreshTimeOut;
currentTrackName ="";

function InitCount()
{
  count = 0;
  document.getElementById("AVG").innerText = "--";
  document.getElementById("TAP").innerText = "--";
	if (window.BPMiTunes)
	{
		if(BPMiTunes.currentTrack())
		{
			if(BPMiTunes.bpm()>0)
				document.getElementById("AVG").innerText = BPMiTunes.bpm();
		}
	}
}

function ResetCount()
{
  count = 0;
  document.getElementById("AVG").innerText = "--";
  document.getElementById("TAP").innerText = "--";
	if (window.BPMiTunes)
	{
		if(BPMiTunes.currentTrack())
		{
			if(BPMiTunes.bpm()>0)
				document.getElementById("AVG").innerText = BPMiTunes.bpm();
		}
	}
}

function TapForBPM(e)
{
  timeSeconds = new Date;
  secs = timeSeconds.getTime();
  if ((secs - secsPrevious) > 1000 * 2)//document.BEATSPERMINUTE.WAIT.value)
  {
    count = 0;
  }

  if (count == 0)
  {
    document.getElementById("AVG").innerText = "--";
    document.getElementById("TAP").innerText = "1";
    secsFirst = secs;
    count = 1;
  }
  else
  {
    bpmAvg = 60000 * count / (secs - secsFirst);
    //document.getElementById("AVG").innerText = (Math.round(bpmAvg * 100)) / 100;
	document.getElementById("AVG").innerText = (Math.round(bpmAvg));
    count++;
	document.getElementById("TAP").innerText = count;
  }
  secsPrevious = secs;
  return true;
}

document.onkeydown = TapForBPM;
document.onclick = displayCurrentTrackName;

function copyBPM2iTunes()
{
	if (window.BPMiTunes)
	{
		if(document.getElementById("AVG").innerText != "--" && BPMiTunes.currentTrack())
		{
			BPMiTunes.setTaps_(document.getElementById("TAP").innerText);
			BPMiTunes.setBpm_(document.getElementById("AVG").innerText);
		}
	}
}

function displayCurrentTrackName()
{
	if (window.BPMiTunes)
	{
		if(BPMiTunes.currentTrack())
		{
			if(currentTrackName != BPMiTunes.currentTrack())
			{
				currentTrackName = BPMiTunes.currentTrack();
				document.getElementById("currentTrack").innerText = BPMiTunes.currentTrack();
				if(BPMiTunes.bpm()>0)
					document.getElementById("AVG").innerText = BPMiTunes.bpm();
				else
					document.getElementById("AVG").innerText = "--";
				document.getElementById("TAP").innerText = "--";
			}
		}
		else
		{
			document.getElementById("currentTrack").innerText = "Nothing Playing";
			document.getElementById("AVG").innerText = "--";
			document.getElementById("TAP").innerText = "--";
		}
		refreshTimeOut = setTimeout('displayCurrentTrackName()',500);
	}
}

function highlightAddToITunesButton(on)
{
	if(on==1)
	{
		document.getElementById("addToITunesButtonBG_hightlight").style.display = "block";
		document.getElementById("addToITunesButtonBG").style.display = "none";
	}
	else
	{
		document.getElementById("addToITunesButtonBG_hightlight").style.display = "none";
		document.getElementById("addToITunesButtonBG").style.display = "block";
	}
}

function highlightResetButton(on)
{
	if(on==1)
	{
		document.getElementById("resetButtonBG_hightlight").style.display = "block";
		document.getElementById("resetButtonBG").style.display = "none";
	}
	else
	{
		document.getElementById("resetButtonBG_hightlight").style.display = "none";
		document.getElementById("resetButtonBG").style.display = "block";
	}
}

newVersionURL = "";
function downloadNewVersion()
{
	if(newVersionURL!="")
		widget.openURL(newVersionURL);
}

// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	document.getElementById("shade").style.display = "none";
	document.getElementById("newVersionAvailable").style.display = "none";
	document.getElementById("downloadNewVersionButton").style.display = "none";

	document.getElementById("addToITunesButtonBG_hightlight").style.display = "none";
	document.getElementById("resetButtonBG_hightlight").style.display = "none";
    setupParts();
	ResetCount();
	document.onkeydown = TapForBPM;

	if (window.BPMiTunes)
	{
		newVersionURL = BPMiTunes.lastVersionURL();
		if(BPMiTunes.lastVersionURL()!="")
		{
			document.getElementById("shade").style.display = "block";
			document.getElementById("newVersionAvailable").style.display = "block";
			document.getElementById("downloadNewVersionButton").style.display = "block";
		}
	}
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	clearTimeout(refreshTimeOut);
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	displayCurrentTrackName();
	//InitCount();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
	displayCurrentTrackName();
	//InitCount();
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	displayCurrentTrackName();
	InitCount();
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
